# coding: utf-8

"""
    Developer API - URLR

    API powering the features of URLR.

    The version of the OpenAPI document: 0.3
    Contact: contact@urlr.me
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ReduceLink200Response(BaseModel):
    """
    ReduceLink200Response
    """ # noqa: E501
    url: Optional[StrictStr] = Field(default=None, description="Original URL")
    expired_at: Optional[StrictStr] = Field(default=None, description="Expiration date")
    team: Optional[StrictInt] = Field(default=None, description="Team ID (displayed on dashboard)")
    folder: Optional[StrictInt] = Field(default=None, description="Folder ID (displayed on dashboard)")
    url_code: Optional[StrictStr] = Field(default=None, description="Short code")
    domain: Optional[StrictStr] = Field(default=None, description="Domain")
    code: Optional[StrictInt] = Field(default=None, description="HTTP status code")
    __properties: ClassVar[List[str]] = ["url", "expired_at", "team", "folder", "url_code", "domain", "code"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReduceLink200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReduceLink200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "expired_at": obj.get("expired_at"),
            "team": obj.get("team"),
            "folder": obj.get("folder"),
            "url_code": obj.get("url_code"),
            "domain": obj.get("domain"),
            "code": obj.get("code")
        })
        return _obj


